Subject: Re: [bitcoin-dev] Add a moving checkpoint to the Bitcoin protocol

From: "Kenshiro []" <[email-masked]>
Date: Sat, 3 Aug 2019 10:35:51 +0000

Good point, for the moving checkpoint a number of blocks (or maybe a timestamp) could be enough, but for the block limit of X blocks to decide if the moving checkpoint is ignored or not, as we have to compare two chains (main chain and fork) maybe is much better to measure the blockchain lengths as numberOfBlocks * averageBlockDifficulty, so if a difficulty adjustment happens in that time interval, it's taken into account.

Regards

________________________________
From: LORD HIS EXCELLENCY JAMES HRMH <[email-masked]>
Sent: Saturday, August 3, 2019 2:51
To: Ethan Heilman <[email-masked]>; Bitcoin Dev <[email-masked]>; Kenshiro [] <[email-masked]>
Subject: Re: [bitcoin-dev] Add a moving checkpoint to the Bitcoin protocol

I have but one point to make in a brief catch-up read over.

With the current protocol the fix to a network split is simple, the longest chain win. But with the moving checkpoint I'm proposing we have a problem if both chains began to differ more than N blocks ago, the forks are permanent. So we need an additional rule to ignore the moving checkpoint, a limit of X blocks:

It is not to be considered the longest chain, it is to be considered the longest chain with the most proof of work.

Regards,
LORD HIS EXCELLENCY JAMES HRMH
<https://earn.com/willtech>

________________________________
From: [email-masked] <[email-masked]> on behalf of Kenshiro [] via bitcoin-dev <[email-masked]>
Sent: Friday, 2 August 2019 11:08 PM
To: Ethan Heilman <[email-masked]>; Bitcoin Dev <[email-masked]>
Subject: Re: [bitcoin-dev] Add a moving checkpoint to the Bitcoin protocol

Hi all,

Very good points. I did some clarifications in a private conversation, the new rule is making the moving checkpoint valid only if the difference in blocks between the main chain and the new fork is smaller than X blocks, like for example 3 days of blocks, so after a long network split everyone can finally follow the longest chain:

With the current protocol the fix to a network split is simple, the longest chain win. But with the moving checkpoint I'm proposing we have a problem if both chains began to differ more than N blocks ago, the forks are permanent. So we need an additional rule to ignore the moving checkpoint, a limit of X blocks:

If a node sees a fork longer than his main chain, and the fork has at least X blocks more than the main chain, then the node ignore the moving checkpoint rule, and it follows the fork, the longest chain.

So as an example, the moving checkpoint could be 24 hours of blocks, and the limit of X blocks, the blocks of 3 days.

So we have 2 possible situations to consider:

- 51% attack:  the blocks older than 24 hours are protected against a history rewrite during at least 3 days, in that time developers could release an emergency release with another mining algorithm to stop the attack.

- Network split: if the network split is older than N blocks, we have 2 permanent forks (or chains), but in 3 days (or more) the blockchain heights will differ in more than X blocks (the blocks of 3 days) because there will be more miners in one chain than in the other so finally the loser chain will be abandoned and everyone will follow the longest chain.

It could be even more conservative, like 48 hours for the moving checkpoint and a block limit of 7 days of blocks.

Regards,

________________________________
From: Ethan Heilman <[email-masked]>
Sent: Friday, August 2, 2019 14:19
To: Kenshiro [] <[email-masked]>; Bitcoin Dev <[email-masked]>
Cc: Alistair Mann <[email-masked]>
Subject: Re: [bitcoin-dev] Add a moving checkpoint to the Bitcoin protocol

Attack 1:
I partition (i.e. eclipse) a bunch of nodes from the network this partition contains no mining power . I then mine 145 blocks for this partition. I don't even need 51% of the mining power because I'm not competing with any other miners. Under this rule this partition will hardfork from the network permanently. Under current rules this partition will be able to rejoin the network as the least weight chain will be orphaned.

Attack 2:
I pre-mine 145 blocks. A node goes offline for 24 hours, when it rejoins I feed it 145 blocks which fork off from the consensus chain. I have 24+24 hours to mine these 145 blocks so I should be able to do this with 25% of the current hash rate at the time the node went offline. Under your rule each of these offline-->online nodes I attack this way will hardfork themselves from the rest of the network.

I believe a moving-checkpoint rule as describe above would make Bitcoin more vulnerable to 51% attacks.

A safer rule would be if a node detects a fork with both sides of the split having  length > 144 blocks, it halts and requests user intervention to determine which chain to follow.  I don't think 144 blocks is a great number to use here as 24 hours is very short. I suspect you could improve the security of the rule by making the number of blocks a fork most reach to halt the network proportional to the difference in time between the timestamp in the block prior to the fork and the current time. I am **NOT** proposing Bitcoin adopt such a rule.

NXT has a fundamentally different security model as it uses Proof-of-stake rather than Proof-of-Work.

On Wed, Jul 31, 2019 at 2:37 PM Kenshiro [] via bitcoin-dev <[email-masked]<mailto:[email-masked]>> wrote:
P.S.: To be clearer, in this example I set an N value of 144 blocks, which is approximately 24 hours.

________________________________
From: Kenshiro [] <[email-masked]<mailto:[email-masked]>>
Sent: Wednesday, July 31, 2019 16:40
To: Alistair Mann <[email-masked]<mailto:[email-masked]>>; Bitcoin Protocol Discussion <[email-masked]<mailto:[email-masked]>>
Subject: Re: [bitcoin-dev] Add a moving checkpoint to the Bitcoin protocol

>>> How would a (potentially, state-sponsored) netsplit lasting longer than N be
handled?

It would be detected by the community much before reaching the reorg limit of N blocks (it's 24 hours) so nodes could stop until the netsplit is fixed.

In the extreme case no one notice the network split during more than N blocks (24 hours) and there are 2 permanent forks longer than N, nodes from one branch could delete their local history so they would join the other branch.

Regards,

________________________________
From: Alistair Mann <[email-masked]<mailto:[email-masked]>>
Sent: Wednesday, July 31, 2019 15:59
To: Kenshiro [] <[email-masked]<mailto:[email-masked]>>; Bitcoin Protocol Discussion <[email-masked]<mailto:[email-masked]>>
Subject: Re: [bitcoin-dev] Add a moving checkpoint to the Bitcoin protocol

On Wednesday 31 Jul 2019 12:28:58 Kenshiro [] via bitcoin-dev wrote:

> I would like to propose that a "moving checkpoint" is added to the Bitcoin
> protocol. It's a very simple rule already implemented in NXT coin:
>
> - A node will ignore any new block under nodeBlockHeight - N, so the
> blockchain becomes truly immutable after N blocks, even during a 51% attack
> which thanks to the moving checkpoint can't rewrite history older than the
> last N blocks.

How would a (potentially, state-sponsored) netsplit lasting longer than N be
handled?
--
Alistair Mann

_______________________________________________
bitcoin-dev mailing list
[email-masked]<mailto:[email-masked]>
https://lists.linuxfoundation.org/mailman/listinfo/bitcoin-dev